 <style>
  .el-table .cell{
    white-space: pre-line;
  }
 </style>

<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="任务名" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="资源名" prop="resources">
        <el-input v-model="queryParams.resources" placeholder="请输入" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="开始时间">
        <el-date-picker v-model="dateRangePlanStartTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item label="结束时间">
        <el-date-picker v-model="dateRangePlanEndTime" style="width: 240px" value-format="yyyy-MM-dd"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" />
      </el-form-item>
      <el-form-item label="优先级" prop="weight">
        <el-input v-model="queryParams.weight" placeholder="请输入优先级" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['farm:task:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['farm:task:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" stripe :data="list">
      <el-table-column label="任务ID" align="center" prop="id" />
      <el-table-column label="项目名" align="center" prop="projectName" >
        <template slot-scope="scope">
          <span> {{projectList.find(t=>t.id == scope.row.projectId ).name}}  </span>
        </template>
      </el-table-column>
      <el-table-column label="负责人" align="center" prop="mainPerson" >
        <template slot-scope="scope">
          <span> {{cpUserList.find(t=>t.id == scope.row.mainPerson ).name}}  </span>
        </template>
      </el-table-column>
      <el-table-column label="执行人" align="center" prop="executorPerson"/>

      <el-table-column label="作物名" align="center" prop="cropName" >
        <template slot-scope="scope">
          <span> {{cropList.find(t=>t.id == scope.row.cropId ).name}}  </span>
        </template>
      </el-table-column>
      <el-table-column label="作物数量" align="center" prop="cropNum" />
      <el-table-column label="任务名" align="center" prop="name" />
      <el-table-column label="任务内容" align="center" prop="content" />
      <el-table-column label="需要的资源" align="center" prop="resources" />
      <el-table-column label="工时" align="center" prop="workingHours" />

      <el-table-column label="图片" align="center" prop="images" >
        <template slot-scope="scope"> 
            <el-image 
              v-if="scope.row.images[0] != null"
              style=""
              :src="scope.row.images[0]" 
              :preview-src-list="scope.row.images">
            </el-image>
        </template>
      </el-table-column>
      <el-table-column label="开始时间" align="center" prop="planStartTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.planStartTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="截止时间" align="center" prop="planEndTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.planEndTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="优先级" align="center" prop="weight" />
      <el-table-column label="" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['farm:task:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['farm:task:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">

        <el-form-item label="项目选择" prop="projectId">
          <el-select  v-model="form.projectId"  placeholder="请选择">
            <el-option
              v-for="item in projectList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="负责人" prop="mainPerson">
          <el-select  v-model="form.mainPerson"  placeholder="请选择">
            <el-option
              v-for="item in cpUserList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="执行人" prop="executorPerson">
          <el-select  v-model="executorPerson" multiple placeholder="请选择" >
            <el-option
              v-for="item in cpUserList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="作物选择" prop="cropId">
          <el-select  v-model="form.cropId"  placeholder="请选择">
            <el-option
              v-for="item in cropList"
              :key="item.id"
              :label="item.name"
              :value="item.id">
              {{item.name}}
            </el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="作物数量" prop="cropNum">
          <el-input v-model="form.cropNum" placeholder="请输入"/>
        </el-form-item>
        <el-form-item label="任务名" prop="name">
          <el-input v-model="form.name" placeholder="请输入" />
        </el-form-item>
        <el-form-item label="任务内容" prop="content">
          <editor v-model="form.content" :min-height="192"/>
        </el-form-item>


        <div v-for="(item,index) in resourceTypeList" :key="index">    
          <el-form-item label="资源选择">
            <el-cascader 
            :options="twoList" 
            :props="props" 
            collapse-tags 
            clearable 
            v-model="form.resources">
            </el-cascader>
            <el-button @click="addR(index)">添加</el-button>
            <el-button @click="delR(index)">删除</el-button>
          </el-form-item>
        </div>

        <el-form-item label="工时" prop="workingHours">
          <el-input v-model="form.workingHours" placeholder="请输入工时" />
        </el-form-item>

        <el-form-item label="任务图片">
          <imageUpload v-model="form.images"/>
        </el-form-item>
        <el-form-item label="任务开始时间" prop="planStartTime">
          <el-date-picker clearable v-model="form.planStartTime" type="date" value-format="timestamp" placeholder="选择" />
        </el-form-item>
        <el-form-item label="任务结束时间" prop="planEndTime">
          <el-date-picker clearable v-model="form.planEndTime" type="date" value-format="timestamp" placeholder="选择" />
        </el-form-item>
        <el-form-item label="优先级" prop="weight">
          <el-input v-model="form.weight" placeholder="请输入优先级" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createTask, updateTask, deleteTask, getTask, getTaskPage, getTaskSearchPage, exportTaskExcel } from "@/api/farm/task";
import ImageUpload from '@/components/ImageUpload';
import Editor from '@/components/Editor';
import { getResourcePage } from "@/api/farm/resource";
import { getProjectPage} from "@/api/farm/project";
import { getCropPage} from "@/api/farm/crop";
import { getResourceTypePage} from "@/api/farm/resourceType";
import { getCpUserPage} from "@/api/system/cpUser"
import { values } from 'min-dash';

export default {
  name: "Task",
  components: {
    Editor,
    ImageUpload,
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 农场项目列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangePlanStartTime: [],
      dateRangePlanEndTime: [],
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        name: null,
        content: null,
        resources: null,
        images: null,
        weight: null,
        projectId: null,
        cropId: null,
        cropNum: null,
        workingHours: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        projectId: [{ required: true, message: "不能为空", trigger: "blur" }],
        mainPerson: [{ required: true, message: "不能为空", trigger: "blur" }],
        executorPerson: [{ required: true, message: "不能为空", trigger: "blur" }],
        cropId: [{ required: true, message: "不能为空", trigger: "blur" }],
        cropNum: [{ required: true, message: "不能为空", trigger: "blur" }],
        name: [{ required: true, message: "不能为空", trigger: "blur" }],
        content: [{ required: true, message: "不能为空", trigger: "blur" }],
        workingHours: [{ required: true, message: "不能为空", trigger: "blur" }],
        planStartTime: [{ required: true, message: "不能为空", trigger: "blur" }],
        planEndTime: [{ required: true, message: "不能为空", trigger: "blur" }],
        weight: [{ required: true, message: "不能为空", trigger: "blur" }],
      },
      resourceList:[],
      selectResourceList:[],
      projectList:[],
      cropList:[],

      resourceTypeList:[],
      selectResourceTypeList:[],

      twoList:[],
      props: { multiple: true },

      selectRList:[],

      cpUserList:[],
      selectExecutorPerson:[],
      executorPerson:[]

    };
  },
  created() {
    this.getResource();
    this.getResourceTypeList();
    this.getProjectList();
    this.getCpUserList();
    this.getCropList();
  },
  methods: {
    getCpUserList(){
      getCpUserPage({
        pageNo: 1,
        pageSize: 100
      }).then(res=>{
        this.cpUserList = res.data.list;
      })
    },
    getCropList(){
      getCropPage({
        pageNo: 1,
        pageSize: 100
      }).then(res=>{
        this.cropList = res.data.list;
      })
    },
    getProjectList(){
      getProjectPage({
        pageNo: 1,
        pageSize: 100
      }).then(res=>{
        this.projectList = res.data.list;
      })
    },
    /**查询资源*/
    getResource(){
      getResourcePage({
        pageNo: 1,
        pageSize: 10,
        name: null,
      }).then(res=>{
        this.resourceList = res.data.list;
        this.getList();
      })
    },
    getResourceTypeList(){
      getResourceTypePage({
        pageNo: 1,
        pageSize: 100
      }).then(res=>{
        this.resourceTypeList = res.data.list;
      })
    },
    /** 查询任务列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangePlanStartTime, 'planStartTime');
      this.addBeginAndEndTime(params, this.dateRangePlanEndTime, 'planEndTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getTaskPage(params).then(response => {

      //1 循环list
      response.data.list.forEach(element => {
        if(element.images != null){
          //有图片转json
          element.images = JSON.parse(element.images);
        }else{
          //无图片给个空
          element.images = [];
        }
        //2 循环每个list对象的resource
        element.resources = JSON.parse(element.resources);
        let resourceName = '';
        element.resources.forEach((inn) =>{
          //3 每个resouce循环比较 resourceList，取得名字
          this.resourceList.forEach((resource) =>{
              if(inn == resource.id){
                resourceName += (resource.name + "、\n");
              }
            }
          )
        })
        element.resources = resourceName;

        element.executorPerson = JSON.parse(element.executorPerson);
        let executorName = '';
        element.executorPerson.forEach((exe)=>{
          this.cpUserList.forEach((cp)=>{
            if(exe == cp.id){
              executorName += (cp.name +"、\n");
            }
          })
        })
        element.executorPerson = executorName;

      });
      this.list = response.data.list;
      this.total = response.data.total;
      this.loading = false;
      });
      this.twoRescoure();
    },
    /** 搜索条件查询任务列表 */
    getSearchList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangePlanStartTime, 'planStartTime');
      this.addBeginAndEndTime(params, this.dateRangePlanEndTime, 'planEndTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getTaskSearchPage(params).then(response => {
        response.data.list.forEach(element => {
          if(element.images != null){
            element.images = JSON.parse(element.images);
          }else{
            element.images = [];
          }
          element.resources = JSON.parse(element.resources);
          let resourceName = '';
          element.resources.forEach((inn) =>{
            this.resourceList.forEach((resource) =>{
                if(inn == resource.id){
                  resourceName += (resource.name + "、\n");
                }
              }
            )
          })
          element.resources = resourceName;
        });
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },

    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        name: undefined,
        content: undefined,
        resources: undefined,
        images: undefined,
        planStartTime: undefined,
        planEndTime: undefined,
        weight: undefined,
        projectName: undefined,
        cropId: undefined,
        cropNum: undefined,
        mainPerson: undefined,
        executorPerson: undefined,
        workingHours: undefined
      };
      this.executorPerson = undefined,

      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getSearchList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangePlanStartTime = [];
      this.dateRangePlanEndTime = [];
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.twoRescoure();
      this.open = true;
      this.title = "添加农场任务";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getTask(id).then(response => {
        this.form = response.data;
        if(response.data.resources != null){
          let resourceArr = JSON.parse(response.data.resources);
          this.form.resources = resourceArr;
          this.selectResourceList = resourceArr;
        }

        if(response.data.images != null){
          let imagesArr = JSON.parse(response.data.images);
          this.form.images = imagesArr;
        }

        if(response.data.executorPerson != null){
          let executorArr = JSON.parse(response.data.executorPerson);
          this.form.executorPerson = executorArr;
        }
        this.open = true;
        this.title = "修改农场任务";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        //资源转json
        this.form.resources = JSON.stringify(this.selectResourceList);
        this.form.executorPerson = JSON.stringify(this.executorPerson);
        //图片转json
        let im = this.form.images;
        this.form.images = JSON.stringify("");
        if (im) {
          //不为空
          let imgArr = im.split(",")
          this.form.images = JSON.stringify(imgArr);
        }

        // 修改的提交
        if (this.form.id != null) {
          updateTask(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createTask(this.form).then(response => {
          this.form.executorPerson = JSON.stringify(this.form.executorPerson);
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除农场项目编号为"' + id + '"的数据项?').then(function() {
          return deleteTask(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangePlanStartTime, 'planStartTime');
      this.addBeginAndEndTime(params, this.dateRangePlanEndTime, 'planEndTime');
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有农场项目数据项?').then(() => {
          this.exportLoading = true;
          return exportTaskExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    },
    twoRescoure(){
        let firstList = [];
        this.resourceTypeList.forEach((type) =>{
          let secondList = [];
          this.resourceList.forEach((res)=>{
            if(res.resourceType == type.id){
              secondList.push({value: res.id, label:res.name});
            }
          })
          firstList.push({value: type.id, label : type.name, children: secondList});
        })
        this.twoList = firstList;
    },
    addR(row){
      console.log("添加", row);
    },
    delR(row){
      console.log("删除", row);
    }
  }
};
</script>
